unit pg;
(*
 * Delphi Sample Code provided by BITWISE MAGAZINE
 * 
 *      http://www.bitwisemag.com
 *
 * This code and information is provided "as is" without warranty of
 * any kind, either expressed or implied, including but not limited
 * to the implied warranties of merchantability and/or fitness for a
 * particular purpose.
 *
 * You may use and modify this code for your personal use only.
 * You may also redistribute this code providing that
 * a) No fee is charged and b) This copyright notice
 * is retained in the source code.
 *
 * You may not use this code for commercial purposes
 * without the express permission of the copyright holder
 *
 * Copyright (c) 2006 Huw Collingbourne 
 *
 *)
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ShellCtrls,
  ShlObj, Menus,
  IniFiles,
  globals,
  childform;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Window1: TMenuItem;
    Tile1: TMenuItem;
    Cascade1: TMenuItem;
    Arrangeicons1: TMenuItem;
    N2: TMenuItem;
    New2: TMenuItem;
    Test: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure Arrangeicons1Click(Sender: TObject);
    procedure NewClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TestClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    paths : TStringList;
    childform : Tchildfm;
    formjustcreated : boolean;
    procedure Init;
    function GetSpecialFolder(nFolder : integer) : string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
implementation

//uses childform;

{$R *.dfm}
function TForm1.GetSpecialFolder(nFolder : integer) : string;
var
  pszPath : array[0..MAX_PATH] of char;
  ppidl : PItemIDList; // Needs ShlObj.pas
begin
  if (SHGetSpecialFolderLocation(0, nFolder, ppidl) ) = S_OK then
  begin
    SHGetPathFromIDList(ppidl, pszPath);
    Result := string(pszPath);
  end
  else Result := '';
end;

procedure TForm1.Init;
begin
  startmenudir := GetSpecialFolder(CSIDL_STARTMENU);
  if startmenudir <> '' then
    Caption := 'Start Menu= "'+startmenudir+'"';
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.Tile1Click(Sender: TObject);
begin
   Tile;
end;

procedure TForm1.Cascade1Click(Sender: TObject);
begin
   Cascade;
end;

procedure TForm1.Arrangeicons1Click(Sender: TObject);
begin
   ArrangeIcons;
end;

procedure TForm1.NewClick(Sender: TObject);
begin
   Tchildfm.Create(Self);
end;

procedure TForm1.TestClick(Sender: TObject);
var
  i : integer;
  s : string;
begin
  s := 'MDIChildCount='+IntToStr(MDIChildCount)+#10#13;
  for i := MDIChildCount-1 downto 0 do
    s := s + '['+IntToStr(i)+']' + MDIChildren[i].Caption + #10#13;
  ShowMessage(s);
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Ini : TIniFile;
  i : integer;
begin
  Ini := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
  try
    Ini.WriteBool( 'Form', 'Maximized', WindowState = wsMaximized );
    WindowState := wsNormal;
    Ini.WriteInteger( 'Form', 'Top', Top);
    Ini.WriteInteger( 'Form', 'Left', Left);
    Ini.WriteInteger('Form','Height', Height);
    Ini.WriteInteger('Form','Width', Width);
    Ini.EraseSection('ProgGroups');
    for i := MDIChildCount-1 downto 0 do
        Ini.WriteString('ProgGroups','Group'+IntToStr(i),MDIChildren[i].Caption);
  finally
    Ini.Free;
  end;

end;


procedure TForm1.FormCreate(Sender: TObject);
var
  Ini: TIniFile;
  s : string;
  i : integer;
begin
  Init;
  s := 'Paths To Program Groups...'+#10#13;;
  Ini := TIniFile.Create( ChangeFileExt( Application.ExeName, '.ini' ) );
  try
    Self.Top     := Ini.ReadInteger( 'Form', 'Top', 100 );
    Self.Left    := Ini.ReadInteger( 'Form', 'Left', 100 );
    Self.Height  := Ini.ReadInteger('Form','Height', 400);
    Self.Width   := Ini.ReadInteger('Form','Width', 600);
    if Ini.ReadBool( 'Form', 'Maximized', false ) then
      WindowState := wsMaximized
    else
      WindowState := wsNormal;
    //!! Read ProgGroups section into path StringList and parse out
    // the values
    paths := TStringList.Create;
    Ini.ReadSectionValues('ProgGroups',paths);
    for i := 0 to paths.Count-1 do
    begin
    s := s + paths[i]+#10#13;
    // !! =======Uncomment the following line to try out ValueFromIndex=======
    //        s := s + paths.ValueFromIndex[i]+#10#13;
    end;
    ShowMessage(s);
    // end of reading ProgGroups
  finally
    ini.Free;
  end;
  formjustcreated := true;
end;



procedure TForm1.FormShow(Sender: TObject);
var
  i : integer;
begin
  if formjustcreated then
  begin
    for i := 0 to paths.Count-1 do
    begin
        childform := Tchildfm.Create(Self);
        childform.SetRootFolder(paths.ValueFromIndex[i]);
    end;
    paths.Free;
    formjustcreated := false;
  end;
end;

end.
