unit childform;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ShellCtrls,
  globals, Menus;

type
  Tchildfm = class(TForm)
    ShellListView: TShellListView;
    ChildMenu1: TMainMenu;
    Group1: TMenuItem;
    Close1: TMenuItem;
    View1: TMenuItem;
    SmallIcons1: TMenuItem;
    LargeIcons1: TMenuItem;
    List1: TMenuItem;
    Details1: TMenuItem;
    OpenOnFolder1: TMenuItem;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    OpenOnFolder2: TMenuItem;
    Close2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure SmallIcons1Click(Sender: TObject);
    procedure LargeIcons1Click(Sender: TObject);
    procedure List1Click(Sender: TObject);
    procedure Details1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Close1Click(Sender: TObject);
    procedure ShellListViewDblClick(Sender: TObject);
    procedure OpenOnFolder1Click(Sender: TObject);
    procedure ShellListViewKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure OpenOnFolder;
    procedure TryToChangeFolder;
    procedure SetRootFolder( path : string );
  end;

var
  childfm: Tchildfm;

implementation
uses pg;

{$R *.dfm}

procedure Tchildfm.FormCreate(Sender: TObject);
begin
  ShellListView.Root := startmenudir+'\';
  Caption := ShellListView.Root;
end;

procedure Tchildfm.SmallIcons1Click(Sender: TObject);
begin
  ShellListView.ViewStyle := vsSmallIcon;
end;

procedure Tchildfm.LargeIcons1Click(Sender: TObject);
begin
  ShellListView.ViewStyle := vsIcon;
end;

procedure Tchildfm.List1Click(Sender: TObject);
begin
  ShellListView.ViewStyle := vsList;
end;

procedure Tchildfm.Details1Click(Sender: TObject);
begin
  ShellListView.ViewStyle := vsReport;
end;

procedure Tchildfm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action := caFree;
end;

procedure Tchildfm.Close1Click(Sender: TObject);
begin
   Close;
end;

procedure Tchildfm.TryToChangeFolder;
// !! Display new root folder if dir has changed
begin
  if ShellListView.RootFolder = nil then
     Caption := ('No Root Folder!')
  else
     Caption := (ShellListView.RootFolder.PathName);
end;

procedure Tchildfm.ShellListViewDblClick(Sender: TObject);
begin
   TryToChangeFolder;
end;

procedure Tchildfm.SetRootFolder( path : string );
begin
   ShellListView.Root := path;
   Caption := path;
end;

procedure Tchildfm.OpenOnFolder;
var
  newchildfm : Tchildfm;
begin
   if ShellListView.SelectedFolder = nil then
      ShowMessage('NIL')
   else
   begin
      // Comment this out to remove debug msg
      // ShowMessage(ShellListView.SelectedFolder.PathName);
      // Only open a valid directory
      if DirectoryExists(ShellListView.SelectedFolder.PathName) then
      begin
        newchildfm := Tchildfm.Create(Form1);
        newchildfm.ShellListView.Root := ShellListView.SelectedFolder.PathName;
        newchildfm.Caption := ShellListView.SelectedFolder.PathName;
      end;
   end;
end;

procedure Tchildfm.OpenOnFolder1Click(Sender: TObject);
begin
   OpenOnFolder;
end;

procedure Tchildfm.ShellListViewKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_Return then
       TryToChangeFolder;
end;

end.
